function effect_init()
	G.efx = {}
	G.efx.blast = { base = loadGraphic("gfx/efx1.png") };
	local i;
	for i=1,8,1 do
		G.efx.blast[i] = cutGraphic( G.efx.blast.base, 64*math.mod(i-1,4), 64*math.floor((i-1)/4), 64, 64 );
	end
	setGraphicAnimeSequence(G.efx.blast,3);
	
	G.efx.shock = loadGraphic("gfx/shockwave.png");
	G.efx.cutin = loadGraphic("gfx/cutin.png");
end

table.insert(INITIALIZER_LIST,effect_init); -- boot{

function createEffectLow(x,y,class)
	local a = createActor(G.common.clear, x, y, LAYER_EFFECT_L,class);
end

function createEffectHigh(x,y,class)
	local a = createActor(G.common.clear, x, y, LAYER_EFFECT_H,class);
end

function blast_OnStart()
	setGraphic(G.efx.blast[1]);
	addMover(iSelf(),24,1,MOVER_VANISH);
	addMover(iSelf(),-1,1,MOVER_SETZOOM,4.0,4.0);
	addMover(iSelf(),-1,1,MOVER_TURNHEADING,-4.0);
	playSound(S.bossdead);
	release();
end

function blast_OnStep()
end

function blast_OnVanish()
end

function wave_OnStart()
	-- [64] = 2 c O3]
	-- [65] = X]
	-- [66] = Y]
	-- [67] = O~a
	-- [68] = ~a
	-- [69] = |
	-- [72] = Z
	--
	
	VAR[64] = 2;
	VAR[65] = randMT(360);
	VAR[66] = randMT(360);
	VAR[67] = 1;
	VAR[68] = 1;
	VAR[69] = 16;
	setGraphic(G.efx.shock);
	playSound(S.zakodead);
	for i=1,12,1 do
		d=math.random(0,360)
		l=math.random(20,50)
		uid=createActor(G.bullets[5],0,0,d,l/10,LAYER_EFFECT_H)
		addMover(uid,0,1,MOVER_SETBLEND,BLEND_ADD)
		addMover(uid,0,1,MOVER_SETALPHA,192)
		addMover(uid,0, 1,MOVER_SETZOOM ,0.6,0.6)
		addMover(uid,0,20,MOVER_ADDZOOM ,-0.02,-0.02)
		addMover(uid,20,1,MOVER_VANISH)
	end
end

function wave_OnStep()
	if(getUptime()>30)then
		vanish();
	end
	VAR[67] = getUptime()*2;
	VAR[68] = (1-math.cos(math.rad(3*getUptime())))*60;
end

function wave_OnVanish()
	
end

function cutin_OnStart()
	playSound(S.bossshow);
	setGraphic(G.common.black);
	addMover(iSelf(),-1,1,MOVER_SETALPHA,192);
	addMover(iSelf(),-1,1,MOVER_SETPOSITION,0,0);
	addMover(iSelf(),-1,1,MOVER_SETZOOM,640,480);
	addMover(iSelf(),90,40,MOVER_ADDALPHA,-(192/40));
	addMover(iSelf(),130,1,MOVER_VANISH);
	
	local a = createActor(G.efx.cutin,640,240,LAYER_EFFECT_L);
	addMover(a,-1,1,MOVER_SETALPHA,128);
	addMover(a,0,1,MOVER_SETVECTOR,-16,0);
	addMover(a,20,1,MOVER_SETVECTOR,-0.1,0);
	addMover(a,90,1,MOVER_SETVECTOR,-3,0);
	addMover(a,90,40,MOVER_ADDZOOM,0.1,0.1);
	addMover(a,90,40,MOVER_ADDALPHA,-(128/40));
	addMover(a,130,1,MOVER_VANISH);
	release();
end

function cutin_OnStep()
end

function cutin_OnVanish()
end

function bossdead_OnStart()
	startThread("bossdeadThread");
end

function bossdead_OnStep()
	if(isThreadRunning()==false) then vanish(); end
end

function bossdead_OnVanish()
end

function bossdeadThread()
	local i = 0;
	for i=1,16,1 do
		createEffectLow(randMT(-100,100),randMT(-100,100),"wave");
		wait(3);
	end
	createEffectLow(0,0,"blast");
end

function createAura(time,startAlpha,Blend,layer)
	local gHandle = getPattern(iSelf())
	local uID = createActor(gHandle,0,0,layer)
		addMover(uID,0,1,MOVER_SETALPHA,startAlpha)
		addMover(uID,0,1,MOVER_SETBLEND,Blend)
		addMover(uID,0,time,MOVER_ADDALPHA,-startAlpha/time)
		addMover(uID,time,1,MOVER_VANISH)
	return uID;
end
